"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var getBuildPath_1 = require("./utils/getBuildPath");
var FrameworkBuildError_1 = __importDefault(require("@xdn/core/errors/FrameworkBuildError"));
var path_1 = require("path");
var deploy_1 = require("@xdn/core/deploy");
var appDir = process.cwd();
var distDir = path_1.join(appDir, 'dist');
var builder = new deploy_1.DeploymentBuilder(appDir);
function build(_a) {
    var skipFramework = (_a === void 0 ? {
        skipFramework: false,
    } : _a).skipFramework;
    return __awaiter(this, void 0, void 0, function () {
        var e_1, serverPath, assetsPath;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    builder.clearPreviousBuildOutput();
                    if (!!skipFramework) return [3 /*break*/, 4];
                    // clear dist directory
                    builder.emptyDirSync(distDir);
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    // run the ssr build command
                    return [4 /*yield*/, builder.exec('npm run build:ssr')];
                case 2:
                    // run the ssr build command
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _b.sent();
                    throw new FrameworkBuildError_1.default('Angular');
                case 4:
                    serverPath = getBuildPath_1.getOutputPath('server');
                    assetsPath = getBuildPath_1.getOutputPath('build');
                    builder
                        // Include the angular server which is loaded by the prod entrypoint
                        .addJSAsset(path_1.join(appDir, serverPath, 'main.js'), path_1.join('__backends__', 'angular-server.js'))
                        // angular.json
                        .addJSAsset(path_1.join(appDir, 'angular.json'), 'angular.json')
                        // browser assets
                        .addStaticAsset(path_1.join(appDir, assetsPath), '/')
                        // Index html required by Universal engine
                        .addJSAsset(path_1.join(appDir, assetsPath, 'index.html'), path_1.join('/', assetsPath, 'index.html'));
                    return [4 /*yield*/, builder.build()];
                case 5:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = build;
