"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var nonWebpackRequire_1 = __importDefault(require("@xdn/core/utils/nonWebpackRequire"));
/**
 * Gets the contents of angular.json as an object
 */
function getAngularConfig() {
    var angularConfigPath = path_1.join(process.cwd(), 'angular.json');
    return nonWebpackRequire_1.default(angularConfigPath);
}
exports.getAngularConfig = getAngularConfig;
/**
 * Returns the config for the defaultProject in angularConfig.json,
 * or the config for env.ANGULAR_PROJECT if defined
 */
function getAngularProject() {
    var angularConfig = getAngularConfig();
    return process.env.ANGULAR_PROJECT || angularConfig.defaultProject;
}
exports.getAngularProject = getAngularProject;
/**
 * Gets the outputPath prop from angular.json for the given project and type under
 * /projects/<angular-project>/architect/<type>/options
 */
function getOutputPath(type) {
    var angularConfig = getAngularConfig();
    var angularProject = getAngularProject();
    return angularConfig.projects[angularProject].architect[type].options.outputPath;
}
exports.getOutputPath = getOutputPath;
exports.getBuildPath = function () { return getOutputPath('build'); };
